<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: Socket Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="classSocket-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Socket Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Encapsulate a socket.  
 <a href="classSocket.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="Socket_8h_source.html">Socket.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a3f749d9a206e48a875e8c24f29500a93"><td class="memItemLeft" align="right" valign="top"><a id="a3f749d9a206e48a875e8c24f29500a93"></a>
<a class="el" href="classSocket.html">Socket</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSocket.html#a3f749d9a206e48a875e8c24f29500a93">accept</a> ()</td></tr>
<tr class="memdesc:a3f749d9a206e48a875e8c24f29500a93"><td class="mdescLeft">&#160;</td><td class="mdescRight">Accept a new socket. <br /></td></tr>
<tr class="separator:a3f749d9a206e48a875e8c24f29500a93"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adc1e8efb9384ac637d42e93008debb6a"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSocket.html#adc1e8efb9384ac637d42e93008debb6a">bind</a> (uint16_t port, uint32_t address)</td></tr>
<tr class="memdesc:adc1e8efb9384ac637d42e93008debb6a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Bind an address/port to a socket. Specify a port of 0 to have a local port allocated. Specify an address of INADDR_ANY to use the local server IP.  <a href="#adc1e8efb9384ac637d42e93008debb6a">More...</a><br /></td></tr>
<tr class="separator:adc1e8efb9384ac637d42e93008debb6a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aef06605c6725958004116983f1a2051f"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSocket.html#aef06605c6725958004116983f1a2051f">close</a> ()</td></tr>
<tr class="memdesc:aef06605c6725958004116983f1a2051f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Close the socket.  <a href="#aef06605c6725958004116983f1a2051f">More...</a><br /></td></tr>
<tr class="separator:aef06605c6725958004116983f1a2051f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae537e61bb9f64b0322c6e9c39bb24fde"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSocket.html#ae537e61bb9f64b0322c6e9c39bb24fde">connect</a> (struct in_addr address, uint16_t port)</td></tr>
<tr class="memdesc:ae537e61bb9f64b0322c6e9c39bb24fde"><td class="mdescLeft">&#160;</td><td class="mdescRight">Connect to a partner.  <a href="#ae537e61bb9f64b0322c6e9c39bb24fde">More...</a><br /></td></tr>
<tr class="separator:ae537e61bb9f64b0322c6e9c39bb24fde"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a426b128c26cee34ed153c1402cf4a5fc"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSocket.html#a426b128c26cee34ed153c1402cf4a5fc">connect</a> (char *address, uint16_t port)</td></tr>
<tr class="memdesc:a426b128c26cee34ed153c1402cf4a5fc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Connect to a partner.  <a href="#a426b128c26cee34ed153c1402cf4a5fc">More...</a><br /></td></tr>
<tr class="separator:a426b128c26cee34ed153c1402cf4a5fc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a788b0d2a4070a64fb38d2c6e6289f96e"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSocket.html#a788b0d2a4070a64fb38d2c6e6289f96e">createSocket</a> (bool isDatagram=false)</td></tr>
<tr class="memdesc:a788b0d2a4070a64fb38d2c6e6289f96e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Create the socket.  <a href="#a788b0d2a4070a64fb38d2c6e6289f96e">More...</a><br /></td></tr>
<tr class="separator:a788b0d2a4070a64fb38d2c6e6289f96e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad435a8a36e2759203db8b4b2c67e4e85"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSocket.html#ad435a8a36e2759203db8b4b2c67e4e85">setReuseAddress</a> (bool value)</td></tr>
<tr class="memdesc:ad435a8a36e2759203db8b4b2c67e4e85"><td class="mdescLeft">&#160;</td><td class="mdescRight">Flag the socket address as re-usable.  <a href="#ad435a8a36e2759203db8b4b2c67e4e85">More...</a><br /></td></tr>
<tr class="separator:ad435a8a36e2759203db8b4b2c67e4e85"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0bee77d0779e5d3a0f62ef7d37e5033d"><td class="memItemLeft" align="right" valign="top"><a id="a0bee77d0779e5d3a0f62ef7d37e5033d"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSocket.html#a0bee77d0779e5d3a0f62ef7d37e5033d">setSocketOption</a> (int option, void *value, size_t len)</td></tr>
<tr class="memdesc:a0bee77d0779e5d3a0f62ef7d37e5033d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the socket option. <br /></td></tr>
<tr class="separator:a0bee77d0779e5d3a0f62ef7d37e5033d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aef6249eaa9b2be5a386f85cb828c2b4a"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSocket.html#aef6249eaa9b2be5a386f85cb828c2b4a">setTimeout</a> (uint32_t seconds)</td></tr>
<tr class="memdesc:aef6249eaa9b2be5a386f85cb828c2b4a"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="classSocket.html" title="Encapsulate a socket.">Socket</a> timeout.  <a href="#aef6249eaa9b2be5a386f85cb828c2b4a">More...</a><br /></td></tr>
<tr class="separator:aef6249eaa9b2be5a386f85cb828c2b4a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6b59f7b6e3be56f4d4a27558bde48e85"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSocket.html#a6b59f7b6e3be56f4d4a27558bde48e85">getBind</a> (struct sockaddr *pAddr)</td></tr>
<tr class="memdesc:a6b59f7b6e3be56f4d4a27558bde48e85"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the bound address.  <a href="#a6b59f7b6e3be56f4d4a27558bde48e85">More...</a><br /></td></tr>
<tr class="separator:a6b59f7b6e3be56f4d4a27558bde48e85"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2ba81037cc4a722e155c7bbbfef58b0d"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSocket.html#a2ba81037cc4a722e155c7bbbfef58b0d">getFD</a> () const</td></tr>
<tr class="memdesc:a2ba81037cc4a722e155c7bbbfef58b0d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the underlying socket file descriptor.  <a href="#a2ba81037cc4a722e155c7bbbfef58b0d">More...</a><br /></td></tr>
<tr class="separator:a2ba81037cc4a722e155c7bbbfef58b0d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac6445aa3f7bd41c6f4466a8b31f2cecd"><td class="memItemLeft" align="right" valign="top"><a id="ac6445aa3f7bd41c6f4466a8b31f2cecd"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>getSSL</b> () const</td></tr>
<tr class="separator:ac6445aa3f7bd41c6f4466a8b31f2cecd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5ccaf81da2b6f25dded056e6dbf7f410"><td class="memItemLeft" align="right" valign="top"><a id="a5ccaf81da2b6f25dded056e6dbf7f410"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>isValid</b> ()</td></tr>
<tr class="separator:a5ccaf81da2b6f25dded056e6dbf7f410"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a893bb9a6107d2139cfb088f0c82ac5ae"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSocket.html#a893bb9a6107d2139cfb088f0c82ac5ae">listen</a> (uint16_t port, bool isDatagram=false, bool reuseAddress=false)</td></tr>
<tr class="memdesc:a893bb9a6107d2139cfb088f0c82ac5ae"><td class="mdescLeft">&#160;</td><td class="mdescRight">Create a listening socket.  <a href="#a893bb9a6107d2139cfb088f0c82ac5ae">More...</a><br /></td></tr>
<tr class="separator:a893bb9a6107d2139cfb088f0c82ac5ae"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9ceb18eb59288e2fc1eb31d631f9dee0"><td class="memItemLeft" align="right" valign="top"><a id="a9ceb18eb59288e2fc1eb31d631f9dee0"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>operator&lt;</b> (const <a class="el" href="classSocket.html">Socket</a> &amp;other) const</td></tr>
<tr class="separator:a9ceb18eb59288e2fc1eb31d631f9dee0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a893006a5a02363d31017ad4f1275e23a"><td class="memItemLeft" align="right" valign="top"><a id="a893006a5a02363d31017ad4f1275e23a"></a>
std::string&#160;</td><td class="memItemRight" valign="bottom"><b>readToDelim</b> (std::string delim)</td></tr>
<tr class="separator:a893006a5a02363d31017ad4f1275e23a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abeb5751e47f3fa96755aba55d29c300a"><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSocket.html#abeb5751e47f3fa96755aba55d29c300a">receive</a> (uint8_t *data, size_t length, bool exact=false)</td></tr>
<tr class="memdesc:abeb5751e47f3fa96755aba55d29c300a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Receive data from the partner. Receive data from the socket partner. If exact = false, we read as much data as is available without blocking up to length. If exact = true, we will block until we have received exactly length bytes or there are no more bytes to read.  <a href="#abeb5751e47f3fa96755aba55d29c300a">More...</a><br /></td></tr>
<tr class="separator:abeb5751e47f3fa96755aba55d29c300a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afc27706410db610051b84cb3c969daa3"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSocket.html#afc27706410db610051b84cb3c969daa3">receiveFrom</a> (uint8_t *data, size_t length, struct sockaddr *pAddr)</td></tr>
<tr class="memdesc:afc27706410db610051b84cb3c969daa3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Receive data with the address.  <a href="#afc27706410db610051b84cb3c969daa3">More...</a><br /></td></tr>
<tr class="separator:afc27706410db610051b84cb3c969daa3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad9757badfe9d9903d07ef7c70279ad77"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSocket.html#ad9757badfe9d9903d07ef7c70279ad77">send</a> (std::string value) const</td></tr>
<tr class="memdesc:ad9757badfe9d9903d07ef7c70279ad77"><td class="mdescLeft">&#160;</td><td class="mdescRight">Send a string to the partner.  <a href="#ad9757badfe9d9903d07ef7c70279ad77">More...</a><br /></td></tr>
<tr class="separator:ad9757badfe9d9903d07ef7c70279ad77"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6d6e3f6b1d0f355575a1bfb350b6477d"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSocket.html#a6d6e3f6b1d0f355575a1bfb350b6477d">send</a> (const uint8_t *data, size_t length) const</td></tr>
<tr class="memdesc:a6d6e3f6b1d0f355575a1bfb350b6477d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Send data to the partner.  <a href="#a6d6e3f6b1d0f355575a1bfb350b6477d">More...</a><br /></td></tr>
<tr class="separator:a6d6e3f6b1d0f355575a1bfb350b6477d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a04f60fe51e2db3db27b2f7731e66e772"><td class="memItemLeft" align="right" valign="top"><a id="a04f60fe51e2db3db27b2f7731e66e772"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>send</b> (uint16_t value)</td></tr>
<tr class="separator:a04f60fe51e2db3db27b2f7731e66e772"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a76de86d175282e3273f932f6f66aa8fe"><td class="memItemLeft" align="right" valign="top"><a id="a76de86d175282e3273f932f6f66aa8fe"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>send</b> (uint32_t value)</td></tr>
<tr class="separator:a76de86d175282e3273f932f6f66aa8fe"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a44a41324fbee63de97bdadc7de03bda3"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSocket.html#a44a41324fbee63de97bdadc7de03bda3">sendTo</a> (const uint8_t *data, size_t length, struct sockaddr *pAddr)</td></tr>
<tr class="memdesc:a44a41324fbee63de97bdadc7de03bda3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Send data to a specific address.  <a href="#a44a41324fbee63de97bdadc7de03bda3">More...</a><br /></td></tr>
<tr class="separator:a44a41324fbee63de97bdadc7de03bda3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a73d0af1a733ff70a622eac54a997f887"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSocket.html#a73d0af1a733ff70a622eac54a997f887">setSSL</a> (bool sslValue=true)</td></tr>
<tr class="memdesc:a73d0af1a733ff70a622eac54a997f887"><td class="mdescLeft">&#160;</td><td class="mdescRight">Flag the socket as using SSL.  <a href="#a73d0af1a733ff70a622eac54a997f887">More...</a><br /></td></tr>
<tr class="separator:a73d0af1a733ff70a622eac54a997f887"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a377ac3bcbf52e36dc08bca6ad0c8a97f"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSocket.html#a377ac3bcbf52e36dc08bca6ad0c8a97f">toString</a> ()</td></tr>
<tr class="memdesc:a377ac3bcbf52e36dc08bca6ad0c8a97f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the string representation of this socket.  <a href="#a377ac3bcbf52e36dc08bca6ad0c8a97f">More...</a><br /></td></tr>
<tr class="separator:a377ac3bcbf52e36dc08bca6ad0c8a97f"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:aa0aa0b437ca534447e335b58e8a30254"><td class="memItemLeft" align="right" valign="top">static std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSocket.html#aa0aa0b437ca534447e335b58e8a30254">addressToString</a> (struct sockaddr *addr)</td></tr>
<tr class="memdesc:aa0aa0b437ca534447e335b58e8a30254"><td class="mdescLeft">&#160;</td><td class="mdescRight">Convert a socket address to a string representation.  <a href="#aa0aa0b437ca534447e335b58e8a30254">More...</a><br /></td></tr>
<tr class="separator:aa0aa0b437ca534447e335b58e8a30254"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Encapsulate a socket. </p>
<p>Using this class we can connect to a partner TCP server. Once connected, we can perform send and receive requests to send and receive data. We should not attempt to send or receive until after a successful connect nor should we send or receive after closing the socket. </p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a id="aa0aa0b437ca534447e335b58e8a30254"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa0aa0b437ca534447e335b58e8a30254">&#9670;&nbsp;</a></span>addressToString()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::string Socket::addressToString </td>
          <td>(</td>
          <td class="paramtype">struct sockaddr *&#160;</td>
          <td class="paramname"><em>addr</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Convert a socket address to a string representation. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">addr</td><td>The address to parse. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A string representation of the address. </dd></dl>

</div>
</div>
<a id="adc1e8efb9384ac637d42e93008debb6a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#adc1e8efb9384ac637d42e93008debb6a">&#9670;&nbsp;</a></span>bind()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int Socket::bind </td>
          <td>(</td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>port</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>address</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Bind an address/port to a socket. Specify a port of 0 to have a local port allocated. Specify an address of INADDR_ANY to use the local server IP. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">port</td><td>Port number to bind. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">address</td><td>Address to bind. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Returns 0 on success. </dd></dl>

</div>
</div>
<a id="aef06605c6725958004116983f1a2051f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aef06605c6725958004116983f1a2051f">&#9670;&nbsp;</a></span>close()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int Socket::close </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Close the socket. </p>
<dl class="section return"><dt>Returns</dt><dd>Returns 0 on success. </dd></dl>

</div>
</div>
<a id="ae537e61bb9f64b0322c6e9c39bb24fde"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae537e61bb9f64b0322c6e9c39bb24fde">&#9670;&nbsp;</a></span>connect() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int Socket::connect </td>
          <td>(</td>
          <td class="paramtype">struct in_addr&#160;</td>
          <td class="paramname"><em>address</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>port</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Connect to a partner. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">address</td><td>The IP address of the partner. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">port</td><td>The port number of the partner. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Success or failure of the connection. </dd></dl>

</div>
</div>
<a id="a426b128c26cee34ed153c1402cf4a5fc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a426b128c26cee34ed153c1402cf4a5fc">&#9670;&nbsp;</a></span>connect() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int Socket::connect </td>
          <td>(</td>
          <td class="paramtype">char *&#160;</td>
          <td class="paramname"><em>strAddress</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>port</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Connect to a partner. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">strAddress</td><td>The string representation of the IP address of the partner. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">port</td><td>The port number of the partner. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Success or failure of the connection. </dd></dl>

</div>
</div>
<a id="a788b0d2a4070a64fb38d2c6e6289f96e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a788b0d2a4070a64fb38d2c6e6289f96e">&#9670;&nbsp;</a></span>createSocket()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int Socket::createSocket </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>isDatagram</em> = <code>false</code></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Create the socket. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">isDatagram</td><td>Set to true to create a datagram socket. Default is false. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The socket descriptor. </dd></dl>

</div>
</div>
<a id="a6b59f7b6e3be56f4d4a27558bde48e85"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6b59f7b6e3be56f4d4a27558bde48e85">&#9670;&nbsp;</a></span>getBind()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Socket::getBind </td>
          <td>(</td>
          <td class="paramtype">struct sockaddr *&#160;</td>
          <td class="paramname"><em>pAddr</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get the bound address. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[out]</td><td class="paramname">pAddr</td><td>The storage to hold the address. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="a2ba81037cc4a722e155c7bbbfef58b0d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2ba81037cc4a722e155c7bbbfef58b0d">&#9670;&nbsp;</a></span>getFD()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int Socket::getFD </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get the underlying socket file descriptor. </p>
<dl class="section return"><dt>Returns</dt><dd>The underlying socket file descriptor. </dd></dl>

</div>
</div>
<a id="a893bb9a6107d2139cfb088f0c82ac5ae"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a893bb9a6107d2139cfb088f0c82ac5ae">&#9670;&nbsp;</a></span>listen()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int Socket::listen </td>
          <td>(</td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>port</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>isDatagram</em> = <code>false</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>reuseAddress</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Create a listening socket. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">port</td><td>The port number to listen upon. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">isDatagram</td><td>True if we are listening on a datagram. The default is false. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Returns 0 on success. </dd></dl>

</div>
</div>
<a id="abeb5751e47f3fa96755aba55d29c300a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abeb5751e47f3fa96755aba55d29c300a">&#9670;&nbsp;</a></span>receive()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t Socket::receive </td>
          <td>(</td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>length</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>exact</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Receive data from the partner. Receive data from the socket partner. If exact = false, we read as much data as is available without blocking up to length. If exact = true, we will block until we have received exactly length bytes or there are no more bytes to read. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">data</td><td>The buffer into which the received data will be stored. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">length</td><td>The size of the buffer. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">exact</td><td>Read exactly this amount. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The length of the data received or -1 on an error. </dd></dl>

</div>
</div>
<a id="afc27706410db610051b84cb3c969daa3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afc27706410db610051b84cb3c969daa3">&#9670;&nbsp;</a></span>receiveFrom()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int Socket::receiveFrom </td>
          <td>(</td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>length</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">struct sockaddr *&#160;</td>
          <td class="paramname"><em>pAddr</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Receive data with the address. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">data</td><td>The location where to store the data. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">length</td><td>The size of the data buffer into which we can receive data. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">pAddr</td><td>An area into which we can store the address of the partner. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The length of the data received. </dd></dl>

</div>
</div>
<a id="ad9757badfe9d9903d07ef7c70279ad77"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad9757badfe9d9903d07ef7c70279ad77">&#9670;&nbsp;</a></span>send() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int Socket::send </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Send a string to the partner. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">value</td><td>The string to send to the partner. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="a6d6e3f6b1d0f355575a1bfb350b6477d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6d6e3f6b1d0f355575a1bfb350b6477d">&#9670;&nbsp;</a></span>send() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int Socket::send </td>
          <td>(</td>
          <td class="paramtype">const uint8_t *&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>length</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Send data to the partner. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">data</td><td>The buffer containing the data to send. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">length</td><td>The length of data to be sent. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="a44a41324fbee63de97bdadc7de03bda3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a44a41324fbee63de97bdadc7de03bda3">&#9670;&nbsp;</a></span>sendTo()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Socket::sendTo </td>
          <td>(</td>
          <td class="paramtype">const uint8_t *&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>length</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">struct sockaddr *&#160;</td>
          <td class="paramname"><em>pAddr</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Send data to a specific address. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">data</td><td>The data to send. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">length</td><td>The length of the data to send/ </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">pAddr</td><td>The address to send the data. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ad435a8a36e2759203db8b4b2c67e4e85"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad435a8a36e2759203db8b4b2c67e4e85">&#9670;&nbsp;</a></span>setReuseAddress()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Socket::setReuseAddress </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Flag the socket address as re-usable. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">value</td><td>True to mark the address as re-usable, false otherwise. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a73d0af1a733ff70a622eac54a997f887"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a73d0af1a733ff70a622eac54a997f887">&#9670;&nbsp;</a></span>setSSL()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Socket::setSSL </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>sslValue</em> = <code>true</code></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Flag the socket as using SSL. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">sslValue</td><td>True if we wish to use SSL. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="aef6249eaa9b2be5a386f85cb828c2b4a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aef6249eaa9b2be5a386f85cb828c2b4a">&#9670;&nbsp;</a></span>setTimeout()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int Socket::setTimeout </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>seconds</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p><a class="el" href="classSocket.html" title="Encapsulate a socket.">Socket</a> timeout. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">seconds</td><td>to wait. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a377ac3bcbf52e36dc08bca6ad0c8a97f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a377ac3bcbf52e36dc08bca6ad0c8a97f">&#9670;&nbsp;</a></span>toString()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::string Socket::toString </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get the string representation of this socket. </p>
<dl class="section return"><dt>Returns</dt><dd>the string representation of the socket. </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="Socket_8h_source.html">Socket.h</a></li>
<li>Socket.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
